; *************************************************************************************************
; * sega rom template 1.4
; *************************************************************************************************
; do not modify the start and end labels
; your code will be reconstructed when compiled in the correct place






;disclaimer:
; this demo was some of my early testing and learning of the sega genesis hardware.
; a game in normal circumstances would use an array to cycle through charcters to reduce code duplication that this code has.
; i have decided to released this as a demo example
; as an added bonus i place two wav files to showcase how to use them.  then should be recorded at 8000khz and <32kb in size


; enjoy





#include	sega\s_main.mdl
#include	sega\s_math.mdl
#include	sega\s_input.mdl
#include	sega\s_dma.mdl
#include	sega\s_collision.mdl
#include	sega\s_saveram.mdl
#include	sega\s_z80.mdl

#segaromwavstart	458752	;wav files start originating
#memstart	16711680	;$ff0000

	org	512
segaromstart

	init_sega()	;get past sega security and clear ram
	init_segavdp()	;setup graphics and irq6 enabled also
	init_z80()		;setup dac

	init_collision()	;setup collision library



	createsinetable(#sinetable)

; setup 4 palettes red,green,blue   0-63 and color 0-7

	sega_palette(#1,#0,#0,#0)	;black 0,0,0
	sega_palette(#2,#2,#2,#2)	;grey	72,72,72 text color on 2
	sega_palette(#3,#4,#4,#4)	;grey	72,72,72 text color on 2
	sega_palette(#4,#7,#7,#7)	;white 255,255,255
	sega_palette(#5,#0,#3,#0)	;dgreen 0,109,0
	sega_palette(#6,#0,#7,#0)	;green 0,255,0
	sega_palette(#7,#0,#7,#7)	;cyan 0,200,200
	sega_palette(#8,#0,#0,#3)	;lblue 0,0,109
	sega_palette(#9,#0,#0,#7)	;blue 0,0,255
	sega_palette(#10,#3,#0,#5)	;purple 109,0,182
	sega_palette(#11,#6,#0,#3)	;pink 218,0,109
	sega_palette(#12,#7,#0,#0)	;red 255,0,0
	sega_palette(#13,#7,#3,#0)	;orange 255,109,0
	sega_palette(#14,#7,#5,#0)	;peach 255,182,0
	sega_palette(#15,#7,#6,#0)	;peachl 255,218,0


	sega_palette(#17,#0,#0,#0)	;black 0,0,0
	sega_palette(#18,#0,#0,#0)	;grey	72,72,72 text color on 2
	sega_palette(#19,#3,#3,#3)	;grey	blue mouse
	sega_palette(#20,#7,#7,#7)	;white 255,255,255
	sega_palette(#21,#0,#4,#0)	;dgreen 0,109,0
	sega_palette(#22,#0,#7,#0)	;green 0,255,0
	sega_palette(#23,#0,#7,#7)	;cyan 0,200,200
	sega_palette(#24,#0,#0,#4)	;lblue 0,0,109
	sega_palette(#25,#0,#0,#7)	;blue 0,0,255
	sega_palette(#26,#3,#0,#5)	;purple 109,0,182
	sega_palette(#27,#6,#0,#3)	;pink 218,0,109
	sega_palette(#28,#7,#0,#0)	;red 255,0,0
	sega_palette(#29,#7,#3,#0)	;orange 255,109,0
	sega_palette(#30,#5,#3,#0)	;peach 255,182,0
	sega_palette(#31,#7,#6,#0)	;peachl 255,218,0




	sega_palette(#33,#0,#0,#0)	;black 0,0,0
	sega_palette(#34,#0,#0,#0)	;
	sega_palette(#35,#7,#0,#0)	;red mouse
	sega_palette(#36,#3,#3,#3)	;
	sega_palette(#37,#4,#4,#4)	;
	sega_palette(#38,#5,#5,#5)	;
	sega_palette(#39,#6,#6,#6)	;
	sega_palette(#40,#7,#7,#7)	;
	sega_palette(#41,#1,#1,#0)	;skin
	sega_palette(#42,#2,#1,#0)	;
	sega_palette(#43,#3,#2,#1)	;
	sega_palette(#44,#4,#3,#2)	;
	sega_palette(#45,#5,#4,#3)	;
	sega_palette(#46,#6,#5,#4)	;
	sega_palette(#47,#7,#6,#5)	;

	sega_palette(#49,#1,#1,#4)	;text
	sega_palette(#50,#3,#3,#3)	;grey
	sega_palette(#51,#7,#7,#7)	;white
	sega_palette(#52,#3,#0,#0)	;red
	sega_palette(#53,#5,#0,#0)	;red
	sega_palette(#54,#7,#0,#0)	;red
	sega_palette(#55,#0,#3,#0)	;green
	sega_palette(#56,#0,#5,#0)	;green
	sega_palette(#57,#0,#7,#0)	;green
	sega_palette(#58,#0,#0,#3)	;blue
	sega_palette(#59,#0,#0,#5)	;blue
	sega_palette(#60,#0,#0,#7)	;blue
	sega_palette(#61,#4,#3,#2)	;skin 150,125,100  5,4,3
	sega_palette(#62,#6,#5,#4)	;skin 200,175,150  6,5,4
	sega_palette(#63,#7,#6,#5)	;skin 250,225,200    7,6,5



	ym_setpatch(#0,#3,#instrument1)
	ym_setpatch(#1,#3,#instrument0)
	ym_setpatch(#2,#3,#instrument1)
	ym_setpatch(#4,#3,#instrument2)
	ym_setpatch(#5,#3,#instrument0)
	ym_setpatch(#6,#3,#instrument0)

	ym_playmusic(#level1,#2,#4,#12,#15)



	sega_font()	;setup diagnostic ascii (tiles 0-95) uses color #2 index


	sega_background(#0,#61)	;change background color

	sega_clearplanea(#0)
	sega_clearplaneb(#0)

;fire 162

	sega_loadtile(#150,#97,#map_tiles)
	sega_loadtile(#250,#4,#main_chr1)	;chr 1 main player



	jsr	load_level1









;player 1 setup
;	move.w	#200,player1_x
;	move.w	#200,player1_y

;player 2 setup
;	move.w	#200,player2_x
;	move.w	#200,player2_y






	device_ports()
	
	move.b	#2,device_porta
	move.b	#2,device_portb



mydo
	jsr	doloop_level1



	bra	mydo






;************************************************************************************************************************************************************************************

linksprites
;	sub.b	#1,sprite
	clr.l	d7
	move.b	sprite,d6
	clr.l	d5
	clr.l	d4
	add.b	#1,d5
getlinks
	if	b,d5!d6
	sega_linksprite(d4,d5)
	else
	sega_linksprite(d4,#0)
	rts
	endif

	add.b	#1,d4
	add.b	#1,d5
	bra	getlinks
	rts


player1_s
	dc.b	'PLAYER 1'
	dc.b	0,0
	even
player2_s
	dc.b	'PLAYER 2'
	dc.b	0,0
	even


def	sprite	byte
def	sprite1	byte




def	spanx	word
def	spany	word
words1
	dc.b	'found!'
	dc.b	0,0
	even

words2
	dc.b	'       '
	dc.b	0,0
	even

def	sinetable	long



def	word	string	16


; make sure all data structures are even.  odd will work on emulation but crash on real hardware


level1

	incbin	'segatune.mdm'	;3250
	even



instrument0
	dc.b	0,0,1,1,1,1,3,3,3,3,9,0,5,1,23,20,50,20,0,0,0,0,31,31,31,31,0,0,0,0,12,7,10,10,7,7,7,9,7,7,7,7,7,7,7,7,0,0,0,0,5,0,68,73,83,84,79,82,84,49,8
	even



instrument1

	dc.b	1,5,1,1,1,1,0,0,0,0,0,15,15,0,22,80,0,20,2,0,0,0,10,10,0,25,0,0,0,0,1,18,1,9,0,7,11,31,9,4,13,15,2,2,0,5,0,0,0,0,5,2,87,65,86,69,89,32,32,32,8
	even



instrument2

	dc.b	0,0,1,1,1,1,0,0,0,0,1,3,3,0,30,30,38,20,1,2,1,1,31,25,31,20,0,0,0,0,5,5,5,7,2,2,2,2,1,1,1,10,1,1,1,6,0,0,0,0,6,2,80,73,65,78,79,95,48,49,8
	even



instrument3
	dc.b	0,0,1,1,1,1,5,4,1,4,10,14,0,1,41,2,89,20,3,3,1,1,1,22,9,26,0,0,0,0,20,30,6,12,16,15,12,7,5,9,11,11,3,4,3,0,0,0,0,0,3,2,77,85,83,73,67,66,79,88,8
	even


instrument4
	dc.b	0,0,1,1,1,1,4,7,7,4,1,10,8,1,40,36,50,20,1,0,1,1,20,20,3,21,0,0,0,0,13,13,8,10,26,24,29,9,6,7,15,14,1,5,0,3,0,0,0,0,4,2,80,73,65,78,79,95,48,51,8
	even



; ***********************************************************************************************
; * code handlers
; ***********************************************************************************************
ignore_handler
	rte	; return from exception

;*************************************************************************************************
;irq 6
;*************************************************************************************************
interrupt6
;push to stack
	movem.l	a0-a6/d0-d7,-(a7)
;process things such as system clock and music player


	systemclock()	;update system clock
	ym_updateplayer()	;update music

;pull from stack
	movem.l	(a7)+,a0-a6/d0-d7
	rte	; return from exception


	incbin	'shoot.wav'	;794
	incbin	'die2.wav'	;4828


; included data goes here before compile automatically

segaromend





